jQuery(document).ready(function () {

  const { __ } = wp.i18n;

  jQuery('.bucw-filter-box').select2({ width: '400px' });

  jQuery(
    "#bucw-filter-container, #bucw-select-categories,#bucw-select-tags,#bucw-select-sku, #bucw-select-product, .bucw-save"
  ).hide();

  jQuery("#filter-type").on("change", function () {
    jQuery('#bucw-filter-container').show();
    var filterType = jQuery(this).val();
    switch (filterType) {
      case "bucw-category":
        jQuery("#bucw-select-categories").show();
        jQuery("#bucw-select-product, #bucw-select-tags,#bucw-select-sku").hide();

        break;

      case "bucw-tags":
        jQuery("#bucw-select-tags").show();
        jQuery("#bucw-select-categories, #bucw-select-sku, #bucw-select-product").hide();

        break;
      case "bucw-product":
        jQuery("#bucw-select-product").show();
        jQuery("#bucw-select-categories, #bucw-select-tags, #bucw-select-sku").hide();

        break;
      case "bucw-sku":
        jQuery("#bucw-select-sku").show();
        jQuery("#bucw-select-categories, #bucw-select-product, #bucw-select-tags").hide();

        break;

      default:
        break;
    }
  });


  // To search all product based on selected taxonomy .

  jQuery("#bucw-search-product").on("click", function () {

    var filterType = jQuery("#filter-type").val();
    var taxonomyID;

    if ("bucw-category" == filterType) {
      var taxonomyID = jQuery("#bucw-multiple-categories").val();
    } else if ("bucw-tags" == filterType) {
      var taxonomyID = jQuery("#bucw-multiple-tags").val();
    } else if ("bucw-product" == filterType) {
      var taxonomyID = [jQuery("#bucw-single-product").val()];
    } else if ("bucw-sku" == filterType) {
      var taxonomyID = jQuery("#bucw-multiple-sku").val();
    } else {
      Swal.fire('', __('Please select a filter ( product category, tags, product name or SKU) to search your products.', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'), 'warning');
      return;
    }

    if (!(taxonomyID === "")) {
      jQuery.ajax({
        url: upsellajaxapi.url,
        type: "POST",
        data: {
          action: "taxonomyID_action",
          nonce: upsellajaxapi.nonce,
          filterType: filterType,
          taxonomyID: taxonomyID,
        },
        success: function (data) {
          if (!data) {
            Swal.fire('', __('No products found on current on selected search criteria. Please change filter or search for other products.', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'), 'warning');
            jQuery("#products-table").hide();

          } else {
            jQuery("#products-table").show();
            jQuery("#products-table").html(data);
            jQuery('.beucw-select2').select2({ width: '100%', minimumInputLength: 2 });
            jQuery(".bucw-save").show();
          }
        },
      });
    } else {
      Swal.fire('', __('Please input  keywords/ terms for the chosen filter for the products you wish to update', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'), 'warning');
    }
  });

  jQuery("#filter-type").on("change", function () {
    jQuery("#products-table").hide();
    jQuery(".bucw-save").hide();
  });

  // To save all ids of upsell and cross-sell products.

  jQuery(".bucw-save").click(function (event) {
    var TableData = []; //initialize array;
    var bucw_data = ""; //empty var;

    //To hide 'Saving Changes..' popup.
    Swal.fire({
      title: __('Saving Changes...', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'),
      html: __('This will take a few seconds.', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'),
      didOpen: () => {
        Swal.showLoading();
      },
    })

    //Here traverse and  read input/select values present in each row, ;
    jQuery("#products-table .product-row").each(function (index, row) {

      var currentRow = null;
      currentRow = jQuery(this);

      TableData[index] = {
        beucw_product_id: currentRow.find('.product-name .bucw-product-title a').attr("id"),
        beucw_product_upsells_ids: currentRow.find('select.upsells-token').val(),
        beucw_product_crosssells_ids: currentRow.find('select.crosssells-token').val(),
      };

      //Convert tableData array to JsonData
      // bucw_data = JSON.stringify(TableData);
    });

    jQuery.ajax({
      url: upsellajaxapi.url,
      method: "POST",
      data: {
        action: "save_all_selected_products",
        nonce: upsellajaxapi.nonce,
        selected_data: TableData,
      },
      success: function (response) {

        Swal.hideLoading();
        Swal.clickConfirm();  // To hide 'Saving Changes..' popup.
        Swal.fire('', __('Products Updated Successfully!', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'), 'success');
        if (0 == jQuery('#bucw-success-massage').length) {
          jQuery("#bucw-upsells-crosssell").before(
            '<div id="bucw-success-massage" class="updated notice is-dismissible"><p>' + __('Products Updated Successfully!', 'bulk-edit-upsells-and-cross-sells-for-woocommerce') + '</p><button id="bucw-dismiss-admin-message" class="notice-dismiss" type="button"><span class="screen-reader-text">Dismiss this notice.</span></button></div>'
          );
        }

        jQuery("#bucw-dismiss-admin-message").click(function (event) {
          jQuery("#bucw-success-massage").remove();
        });
      },
      error: function (jqXHR, textStatus, errorThrown) {

        Swal.fire(__('Some Error Occurred', 'bulk-edit-upsells-and-cross-sells-for-woocommerce'), errorThrown, 'error');
        jQuery("#bucw-upsells-crosssell").before(
          '<div id="bucw-error-massage" class="error notice is-dismissible"><p>' +
          errorThrown +
          '</p><button id="bucw-dismiss-admin-message" class="notice-dismiss" type="button"><span class="screen-reader-text">Dismiss this notice.</span></button></div>'
        );
        jQuery("#bucw-dismiss-admin-message").click(function (event) {
          jQuery("#bucw-error-massage").remove();
        });
      },
    });

  });

  jQuery(document).on('copy', '.beuc-upsells-products span.select2,.beuc-crosssell-products span.select2', function (e) {

    let selectParent = jQuery(this).parent().children("select.beucw-select2");

    if (selectParent.val()) {
      let copyedValues = selectParent.val();
      navigator.clipboard.writeText(copyedValues).then(function () {
      }, function (err) {
        // console.error('Could not copy text: ', err);
      });

    }
  });

  jQuery(document).on('paste', '.beuc-upsells-products span.select2,.beuc-crosssell-products span.select2', function (e) {

    let clipboard = (e.originalEvent || e).clipboardData.getData('text/plain');
    let currentSelect = jQuery(this).parent().children("select.beucw-select2");

    const selectedPId = currentSelect.val();
    const copiedPId = clipboard.split(',');

    const children = selectedPId.concat(copiedPId);

    currentSelect.val(children);
    currentSelect.trigger('change');

    if (!isNaN(Number(copiedPId[0]))) {
      setTimeout(function () {
        currentSelect.parent().find('.select2-search__field').val("");
      }.bind(this), 0);
    }
  });
});
