<?php
/**
 * Add menu function callback.
 */
function beucw_submenu_page() {
	add_submenu_page( 'edit.php?post_type=product', __( 'Upsells & Cross-sells', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ), __( 'Upsells & Cross-sells', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ), 'edit_products', 'bulk-edit-upsells-crosssells', 'beucw_bulk_edit_upsells_submenu_page_callback', 5 );
}

add_action( 'admin_menu', 'beucw_submenu_page' );


/**
 * Add menu function callback.
 */
function beucw_bulk_edit_upsells_submenu_page_callback() {      ?>
<div class="bucw-headingwrap">
	<section class="bucw-header">
		<div>
			<h1><?php echo esc_attr__( 'Bulk Edit UpSells and Cross-sells for WooCommerce', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?> </h1>
		</div>
	</section>
	<main>	
		<form method="get" id="bucw-upsells-crosssell" action="options.php">
		<?php
			settings_fields( 'bucw-section' );
		do_settings_sections( 'bulk-edit-upsells-crosssells' );
		?>
		<div class="footerSavebutton">
			<button type="button" class="bucw-save" id="bucw-save-bottom" ><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Pro 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V173.3c0-17-6.7-33.3-18.7-45.3L352 50.7C340 38.7 323.7 32 306.7 32H64zm0 96c0-17.7 14.3-32 32-32H288c17.7 0 32 14.3 32 32v64c0 17.7-14.3 32-32 32H96c-17.7 0-32-14.3-32-32V128zM224 416c-35.3 0-64-28.7-64-64s28.7-64 64-64s64 28.7 64 64s-28.7 64-64 64z"/></svg> <?php esc_html_e( 'Save', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?> 
		</div>
	</button>
	</form>
	</main>
</div>
	<?php
}


/**
 * Setting field callback function for filter dropdown and tokenfield.
 */
function beucw_products_table() {
	$allowed_html = array(
		'select' => array(
			'id'       => array(),
			'name'     => array(),
			'class'    => array(),
			'value'    => array(),
			'multiple' => array(),
		),
		'option' => array(
			'id'       => array(),
			'value'    => array(),
			'selected' => array(),
		),
	);

	?>
	<div class="bucw-filter-dropdown">
		<div id="bucw-filter-header">
			<div> <select name="filter-type" id="filter-type">
					<option value="filter-by"><?php esc_html_e( 'Select Filter', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></option>
					<option id="bucw-category" value="bucw-category"><?php esc_html_e( 'Category', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></option>
					<option id="bucw-tags" value="bucw-tags"><?php esc_html_e( 'Tags', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></option>
					<option id="bucw-sku" value="bucw-sku"><?php esc_html_e( 'SKU', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></option>
					<option id="bucw-product" value="bucw-product"><?php esc_html_e( 'Product Name', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></option>
				</select>
			</div>
			<div id="bucw-filter-container"> 
				<div id="bucw-select-categories">
					<select class="bucw-filter-box" id="bucw-multiple-categories" name="bucw-multiple-categories[]" data-placeholder="<?php echo esc_attr__( 'Search for categories…', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?>" multiple="multiple">
							<?php echo wp_kses( beucw_select2_get_all_categories(), $allowed_html ); ?>
					</select>
				</div>
				<div id="bucw-select-tags">
					<select class="bucw-filter-box" id="bucw-multiple-tags" name="bucw-multiple-tags[]" data-placeholder="<?php echo esc_attr__( 'Search for tags…', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?>" multiple="multiple">
							<?php echo wp_kses( beucw_select2_get_all_tags(), $allowed_html ); ?>
					</select>
				</div>
				<div id="bucw-select-sku">
				<select class="bucw-filter-box" id="bucw-multiple-sku" name="bucw-multiple-sku[]" data-placeholder="<?php echo esc_attr__( 'Search for SKU…', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?>" multiple="multiple">
						<?php echo wp_kses( beucw_select2_get_all_product_sku(), $allowed_html ); ?>
				</select>
				</div>
				<div id="bucw-select-product">
				<select class="bucw-filter-box" id="bucw-single-product" name="bucw-single-product" data-placeholder="<?php echo esc_attr__( 'Type any product name...', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?>">
				<option value=""></option >';
						<?php
						$all_products = beucw_get_all_products();

						foreach ( $all_products as $beuc_product ) {
							echo '<option value="' . esc_attr( $beuc_product['product_id'] ) . '">' . esc_attr( $beuc_product['label'] ) . '</option >';
						}
						?>
				</select>
				</div>
			</div>
			<div class="bucw-search">
				<button type="button" class="button" id="bucw-search-product" ><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--! Font Awesome Pro 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M416 208c0 45.9-14.9 88.3-40 122.7L502.6 457.4c12.5 12.5 12.5 32.8 0 45.3s-32.8 12.5-45.3 0L330.7 376c-34.4 25.2-76.8 40-122.7 40C93.1 416 0 322.9 0 208S93.1 0 208 0S416 93.1 416 208zM208 352c79.5 0 144-64.5 144-144s-64.5-144-144-144S64 128.5 64 208s64.5 144 144 144z"/></svg><?php esc_html_e( 'Search', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></button>
				<button type="button" class="bucw-save" id="bucw-save-top" > <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Pro 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V173.3c0-17-6.7-33.3-18.7-45.3L352 50.7C340 38.7 323.7 32 306.7 32H64zm0 96c0-17.7 14.3-32 32-32H288c17.7 0 32 14.3 32 32v64c0 17.7-14.3 32-32 32H96c-17.7 0-32-14.3-32-32V128zM224 416c-35.3 0-64-28.7-64-64s28.7-64 64-64s64 28.7 64 64s-28.7 64-64 64z"/></svg><?php esc_html_e( 'Save', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?> 
			</div>
		</div>
	</div>

<div id="products-table" class="products-table">
</div>

	<?php
}


/**
 * Function to add setting field .
 */
function beucw_bulk_edit_settings_function() {
	add_settings_section( 'bucw-section', '', null, 'bulk-edit-upsells-crosssells' );
	add_settings_field( 'bucw-product-categories', esc_attr__( 'Bulk Edit UpSells and Cross-sells for WooCommerce Products', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ), 'beucw_products_table', 'bulk-edit-upsells-crosssells', 'bucw-section', array( 'class' => 'bucw-settings-field' ) );
}
add_action( 'admin_init', 'beucw_bulk_edit_settings_function' );

/**
 * To display all products in tabular format for upsell and cross-sell .
 */
function beucw_taxonomy_id_callback() {
	if ( isset( $_POST['nonce'] ) && isset( $_POST['filterType'] ) && ! empty( $_POST['filterType'] ) && isset( $_POST['taxonomyID'] ) && ! empty( $_POST['taxonomyID'] ) ) {
		if ( ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['nonce'] ) ), 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) ) {
			wp_die( esc_html__( 'Permission Denied.', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) );
		}

		$filter_type = sanitize_text_field( wp_unslash( $_POST['filterType'] ) );

		$taxonomy_id = array_map( 'intval', wp_unslash( $_POST['taxonomyID'] ) );

		switch ( $filter_type ) {
			case 'bucw-category':
				$products_ids = beucw_get_category_products_ids( $taxonomy_id );

				break;
			case 'bucw-tags':
				$products_ids = beucw_get_tags_products_ids( $taxonomy_id );
				break;

			case 'bucw-product':
				$products_ids = array_unique( $taxonomy_id );
				break;

			case 'bucw-sku':
				$products_ids = array_unique( $taxonomy_id );

				break;

			default:
				break;
		}
		if ( ! empty( $products_ids ) && ! ( null === $products_ids ) ) {
			?>
				<div>
					<span><?php esc_html_e( 'Product Name', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></span>  
					<span><?php esc_html_e( 'UpSells', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?><span class="setting-help-tip">
						<div class="tooltipdata"> <?php esc_html_e( 'Please search for your products and set upsells for it in the corressponding box of this column', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?> </div>
					</span></span>
					<span><?php esc_html_e( 'Cross-Sells', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?><span class="setting-help-tip">
						<div class="tooltipdata"> <?php esc_html_e( 'Please search for your products and set cross-sells for it in the corressponding box of this column', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?> </div>
					</span></span>
				</div>
			<?php
			$all_products = beucw_get_all_products_with_variations();
			foreach ( $products_ids as $product_id ) {
				$product        = wc_get_product( $product_id );
				$product_title  = $product->get_title();
				$upsells_ids    = $product->get_upsell_ids();
				$cross_sell_ids = $product->get_cross_sell_ids();
				$product_sku    = $product->get_sku() ? ' (' . $product->get_sku() . ')' : false;
				$thumbnail      = $product->get_image( 'woocommerce_thumbnail' ); // Get the product thumbnail (from product object).

				?>
				<div class="product-row" >
					<div class ="product-name">
						<div class="bucw-product-thumbnail"><a href="<?php echo esc_url( $product->get_permalink() ); ?>" target="_blank">
							<?php
							if ( $product->get_image_id() > 0 ) {
								echo wp_kses_post( $thumbnail );
							} else {
								$source = wc_placeholder_img_src( 'woocommerce_thumbnail' );
								echo '<img src="' . esc_url( $source ) . '">';
							}
							?>
						</a></div>
						<div>
							<span class="bucw-product-name"><?php esc_html_e( 'Product Name', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></span>
							<span class="bucw-product-title"><a id="<?php echo esc_attr( $product_id ); ?>" href="<?php echo esc_url( $product->get_permalink() ); ?>" target="_blank"><?php echo 'ID:' . esc_attr( $product_id ) . ' ' . esc_attr( $product_title ) . ' ' . esc_attr( $product_sku ); ?></a></span>
						</div>
					</div>
					<div class="beuc-upsells-products">
						<span class="bucw-upsells"><?php esc_html_e( 'Upsells', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></span>
						<select class="beucw-select2 upsells-token" id="<?php echo 'upsell-' . esc_attr( $product_id ); ?>" name="<?php echo 'upsell-' . esc_attr( $product_id ) . '[]'; ?>" data-placeholder="<?php echo esc_attr__( 'Search for a product…', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?>" multiple="multiple">
							<?php
							foreach ( $all_products as $beuc_product ) {
								if ( in_array( $beuc_product['product_id'], $upsells_ids, true ) ) {
									echo '<option selected="selected" value="' . esc_attr( $beuc_product['product_id'] ) . '">' . esc_attr( $beuc_product['label'] ) . '</option >';
								} else {
									echo '<option value="' . esc_attr( $beuc_product['product_id'] ) . '">' . esc_attr( $beuc_product['label'] ) . '</option >';
								}
							}
							?>
						</select>
					</div>
					<div class="beuc-crosssell-products">
						<span class="bucw-crosssells"><?php esc_html_e( 'Cross-sells', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></span>
						<select class="beucw-select2 crosssells-token" id="<?php echo 'cross-sell-' . esc_attr( $product_id ); ?>" name="<?php echo 'cross-sell-' . esc_attr( $product_id ) . '[]'; ?>" data-placeholder="<?php echo esc_attr__( 'Search for a product…', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?>" multiple="multiple">
							<?php
							foreach ( $all_products as $beuc_product ) {
								if ( in_array( $beuc_product['product_id'], $cross_sell_ids, true ) ) {
									echo '<option selected="selected" value="' . esc_attr( $beuc_product['product_id'] ) . '">' . esc_attr( $beuc_product['label'] ) . '</option >';
								} else {
									echo '<option value="' . esc_attr( $beuc_product['product_id'] ) . '">' . esc_attr( $beuc_product['label'] ) . '</option >';
								}
							}
							?>
					</select>
					</div>
				</div>
				<?php
			}
		}
	}
	die();
}

add_action( 'wp_ajax_taxonomyID_action', 'beucw_taxonomy_id_callback' );
add_action( 'wp_ajax_nopriv_taxonomyID_action', 'beucw_taxonomy_id_callback' );


/**
 * Show 'Settings' action links on the plugin screen.
 *
 * @param mixed $links Plugin Action links.
 *
 * @return array
 */
function beucw_plugin_setting_link( $links ) {
	$action_links = array(
		'settings' => '<a href="' . admin_url( 'admin.php?page=bulk-edit-upsells-crosssells' ) . '" aria-label="' . esc_attr__( 'Settings', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) . '">' . esc_html__( 'Settings', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) . '</a>',
	);
	return array_merge( $action_links, $links );
}

add_filter( 'plugin_action_links_' . BUCW_BULK_EDIT_PLUGIN_BASENAME, 'beucw_plugin_setting_link', 10, 1 );


/**
 * Update rate Notice.
 */
function beucw_ajax_update_notice() {
	global $current_user;
	if ( isset( $_POST['nonce'] ) && ! empty( $_POST['nonce'] ) ) {
		if ( ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['nonce'] ) ), 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) ) {
			wp_die( esc_html__( 'Permission Denied.', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) );
		}

		update_user_meta( $current_user->ID, 'beucw_rate_notices', 'rated' );
		echo esc_url( network_admin_url() );
	}

	wp_die();
}

add_action( 'wp_ajax_beucw_update', 'beucw_ajax_update_notice' );
add_action( 'wp_ajax_nopriv_beucw_update', 'beucw_ajax_update_notice' );

/**
 * Rating notice widget.
 * Save the date to display notice after 10 days.
 */
function beucw_plugin_notice() {
	global $current_user;
	$user_id = $current_user->ID;
	// if plugin is activated and date is not set then set the next 10 days.
	$today_date = strtotime( 'now' );

	if ( ! get_user_meta( $user_id, 'beucw_notices_time' ) ) {
		$after_10_day = strtotime( '+10 day', $today_date );
		update_user_meta( $user_id, 'beucw_notices_time', $after_10_day );
	}

	// gets the option of user rating status and week status.
	$rate_status = get_user_meta( $user_id, 'beucw_rate_notices', true );
	$next_w_date = get_user_meta( $user_id, 'beucw_notices_time', true );

	// show if user has not rated the plugin and it has been 1 week.
	if ( 'rated' !== $rate_status && $today_date > $next_w_date ) {
		?>
		<div class="notice notice-warning is-dismissible">
			<p><span><?php esc_html_e( "Awesome, you've been using", 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></span><span><?php echo '<strong> Bulk Edit Upsells and Cross-Sells for WooCommerce </strong>'; ?><span><?php esc_html_e( 'for more than 1 week', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></span></p>
			<p><?php esc_html_e( 'If you like our plugin would you like to rate our plugin at WordPress.org ?', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></p>
			<span><a href="https://wordpress.org/plugins/bulk-edit-upsells-and-cross-sells-for-woocommerce/#reviews" target="_blank"><?php esc_html_e( "Yes, I'd like to rate it!", 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></a></span>&nbsp; - &nbsp;<span><a class="beucw_hide_rate" href="#"><?php esc_html_e( 'I already did!', 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ); ?></a></span>
			<br/><br/>
		</div>
		<script>
			let beucwAjaxURL = "<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>";
			let beucwNonce = "<?php echo esc_attr( wp_create_nonce( 'bulk-edit-upsells-and-cross-sells-for-woocommerce' ) ); ?>";
			// redirect to same page after rated.
			jQuery(".beucw_hide_rate").click(function (event) {
				event.preventDefault();
				jQuery.ajax({
					method: 'POST',
					url: beucwAjaxURL,
					data: {
					action: 'beucw_update',
					nonce: beucwNonce,
					},
					success: (res) => {
					window.location.href = window.location.href
					}
				});
			});
		</script>
		<?php
	}
}
add_action( 'admin_notices', 'beucw_plugin_notice' );
